#include <typon/typon.hpp>
#include <typon/logger.hpp>


using namespace typon;

Mutex mutex;

int T = 100000;

Task<void> with_lock()
{
  {
    auto lock = mutex.lock();
    co_await lock;
  }
}

Join<void> parallel() {
  for (int i = 0; i < T; i++) {
    co_await fork(with_lock());
  }
}

Root root() {
  co_await parallel();
}

int main() {
  root().call();
  puts("done");
  return 0;
}
